#ifndef _LINUX_UTSNAME_H
#define _LINUX_UTSNAME_H

#ifdef __KERNEL__
#include <linux/notifier.h>
#endif

#define __OLD_UTS_LEN 8

struct oldold_utsname {
	char sysname[9];
	char nodename[9];
	char release[9];
	char version[9];
	char machine[9];
};

#define __NEW_UTS_LEN 64

struct old_utsname {
	char sysname[65];
	char nodename[65];
	char release[65];
	char version[65];
	char machine[65];
};

struct new_utsname {
	char sysname[65];
	char nodename[65];
	char release[65];
	char version[65];
	char machine[65];
	char domainname[65];
};

extern struct new_utsname system_utsname;

extern struct rw_semaphore uts_sem;

#ifdef __KERNEL__
extern int register_utsname_notifier(struct notifier_block *nb);
extern int unregister_utsname_notifier(struct notifier_block *nb);
#endif

#endif
