/*
 *    sd.h Copyright (C) 1992 Drew Eckhardt 
 *      SCSI disk driver header file by
 *              Drew Eckhardt 
 *
 *      <drew@colorado.edu>
 *
 *       Modified by Eric Youngdale eric@andante.org to
 *       add scatter-gather, multiple outstanding request, and other
 *       enhancements.
 */
#ifndef _SD_H
#define _SD_H
/*
   $Header: /usr/src/linux/kernel/blk_drv/scsi/RCS/sd.h,v 1.1 1992/07/24 06:27:38 root Exp root $
 */

#include "scsi.h"
#include <linux/genhd.h>

#define SCSI_DISK_PART_BITS	4
#define SCSI_DISK_MAX_PART	(1U<<SCSI_DISK_PART_BITS)
#define SCSI_DISK_DISK_SHIFT	(MINORBITS-SCSI_DISK_PART_BITS)
#define SCSI_DISKS_PER_MAJOR	(1U<<SCSI_DISK_DISK_SHIFT)

extern int revalidate_scsidisk(kdev_t dev, int maxusage);

/*
 * Used by pmac to find the device associated with a target.
 */
extern kdev_t sd_find_target(void *host, int tgt);

typedef struct scsi_disk {
	Scsi_Device *device;
	unsigned capacity;		/* size in blocks */
	unsigned char sector_bit_size;	/* sector_size = 2 to the bit size power */
	unsigned char sector_bit_shift;	/* power of 2 sectors per FS block */
	unsigned has_part_table:1;	/* has partition table */
	unsigned ready:1;		/* flag ready for FLOPTICAL */
	unsigned write_prot:1;		/* flag write_protect for rmvable dev */
	unsigned attached:1;		/* has not been detached */
} Scsi_Disk;

extern struct block_device_operations sd_fops;
extern int sd_devname(kdev_t dev, char *buffer);
#endif

