#ifndef _LINUX_HZ_H
#define _LINUX_HZ_H

#include <linux/config.h>
#include <linux/kernel.h>

extern unsigned long __HZ;

static inline unsigned long get_hz(void)
{
#ifdef CONFIG_DEBUG_HZ
	if (unlikely(!__HZ)) {
		__label__ here;
		printk("early HZ: %p\n", &&here);
	here:
		init_HZ(USER_HZ);
	}
#endif /* CONFIG_DEBUG_HZ */
	return __HZ;
}

#define HZ get_hz()

#define CLOCKS_PER_SEC	(USER_HZ)	/* like times() */

#define jiffies_to_clock_t(x)	(likely((HZ) >= (USER_HZ)) ?				\
				 (x + ((HZ) / (USER_HZ)) - 1) / ((HZ) / (USER_HZ)) :	\
				 (x) * ((USER_HZ) / (HZ)))
#define user_to_kernel_hz(x)	(likely((HZ) >= (USER_HZ)) ?				\
				 (x) * ((HZ) / (USER_HZ)) :				\
				 (x + ((USER_HZ) / (HZ)) - 1) / ((USER_HZ) / (HZ)))
#define user_to_kernel_hz_overflow(x)	((x + USER_HZ - 1) * (HZ) / (USER_HZ))

#endif /* _LINUX_HZ_H */
