#ifndef __ASM_PPC_DPROBES_IN_H__
#define __ASM_PPC_DPROBES_IN_H__

/*
 * IBM Dynamic Probes
 * Copyright (c) International Business Machines Corp., 2000
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
 */

/*
 * This header file defines the opcodes for the RPN instructions
 *
 * Opcodes 0x00 to 0xAF are for common, arch-independent instructions.
 * Opcodes 0xB0 to 0xDF are for arch-dependent instructions.
 * Opcodes 0xF1 to 0xFF are for two byte instructions.
 */

/*
 * Misc
 */
#define DP_SEG2LIN		0xB0

/*
 * PPC Register Assignments.
 */
#define DP_NIP          0x0001
#define DP_MSR          0x0002

#define DP_CTR          0x0003
#define DP_LNK          0x0004
#define DP_XER          0x0005
#define DP_CCR          0x0006
#define DP_MQ           0x0007
#define DP_DAR          0x0008
#define DP_DSISR        0x0009
#define DP_FPC          0x000A
#define DP_CPUID        0x000B
   
#define DP_R0  			0x0010 				  
#define DP_R1  			0x0011 				  
#define DP_R2  			0x0012 				  
#define DP_R3  			0x0013 				  
#define DP_R4  			0x0014 				  
#define DP_R5  			0x0015 				  
#define DP_R6  			0x0016 				  
#define DP_R7  			0x0017 				  
#define DP_R8  			0x0018 				  
#define DP_R9  			0x0019 				  
#define DP_R10 			0x001a 				  
#define DP_R11 			0x001b 				  
#define DP_R12 			0x001c 				  
#define DP_R13 			0x001d 				  
#define DP_R14 			0x001e 				  
#define DP_R15 			0x001f 				  
#define DP_R16 			0x0020 				  
#define DP_R17 			0x0021 				  
#define DP_R18 			0x0022 				  
#define DP_R19 			0x0023 				  
#define DP_R20 			0x0024 				  
#define DP_R21 			0x0025 				  
#define DP_R22 			0x0026 				  
#define DP_R23 			0x0027 				  
#define DP_R24 			0x0028 				  
#define DP_R25 			0x0029 				  
#define DP_R26 			0x002a 				  
#define DP_R27 			0x002b 				  
#define DP_R28 			0x002c 				  
#define DP_R29 			0x002d 				  
#define DP_R30 			0x002e 				  
#define DP_R31 			0x002f 				  
								  
#define DP_FPR0    		0x0030
#define DP_FPR1    		0x0031
#define DP_FPR2    		0x0032
#define DP_FPR3    		0x0033
#define DP_FPR4    		0x0034
#define DP_FPR5    		0x0035
#define DP_FPR6    		0x0036
#define DP_FPR7    		0x0037
#define DP_FPR8    		0x0038
#define DP_FPR9    		0x0039
#define DP_FPR10   		0x003a
#define DP_FPR11   		0x003b
#define DP_FPR12   		0x003c
#define DP_FPR13   		0x003d
#define DP_FPR14   		0x003e
#define DP_FPR15   		0x003f
#define DP_FPR16   		0x0040
#define DP_FPR17   		0x0041
#define DP_FPR18   		0x0042
#define DP_FPR19   		0x0043
#define DP_FPR20   		0x0044
#define DP_FPR21   		0x0045
#define DP_FPR22   		0x0046
#define DP_FPR23   		0x0047
#define DP_FPR24   		0x0048
#define DP_FPR25   		0x0049
#define DP_FPR26   		0x004a
#define DP_FPR27   		0x004b
#define DP_FPR28   		0x004c
#define DP_FPR29   		0x004d
#define DP_FPR30   		0x004e
#define DP_FPR31   		0x004f

#ifndef __KERNEL__
#ifndef PAGE_OFFSET
#define PAGE_OFFSET		0xC0000000
#endif
#endif /* !__KERNEL__ */

#endif
