#include <linux/config.h>
#include <linux/module.h>

#include <linux/types.h>
#include <linux/net.h>
#include <linux/smp.h>

#include <net/ipv6.h>
#include <net/addrconf.h>
#include <net/ip6_route.h>
#include <net/mipglue.h>

extern int ip6_route_del(struct in6_rtmsg *rtmsg);
#ifdef USE_IPV6_MOBILITY
extern struct mipv6_callable_functions mipv6_functions;
void mipv6_invalidate_calls(void);
#endif /* USE_IPV6_MOBILITY */

EXPORT_SYMBOL(__ipv6_addr_type);
EXPORT_SYMBOL(addrconf_add_ifaddr);
EXPORT_SYMBOL(addrconf_del_ifaddr);
EXPORT_SYMBOL(addrconf_lock);
EXPORT_SYMBOL(addrconf_pfx_adv_rcv);
EXPORT_SYMBOL(fib6_clean_tree);
EXPORT_SYMBOL(fl6_sock_lookup);
EXPORT_SYMBOL(icmpv6_send);
EXPORT_SYMBOL(icmpv6_statistics);
EXPORT_SYMBOL(in6_dev_finish_destroy);
EXPORT_SYMBOL(inet6_add_protocol);
EXPORT_SYMBOL(inet6_del_protocol);
EXPORT_SYMBOL(inet6_ifa_finish_destroy);
EXPORT_SYMBOL(ip6_build_xmit);
EXPORT_SYMBOL(ip6_del_rt);
EXPORT_SYMBOL(ip6_input);
EXPORT_SYMBOL(ip6_route_add);
EXPORT_SYMBOL(ip6_route_del);
#ifdef CONFIG_NETFILTER
EXPORT_SYMBOL(ip6_route_me_harder);
#endif
EXPORT_SYMBOL(ip6_route_output);
EXPORT_SYMBOL(ip6_routing_table);
EXPORT_SYMBOL(ip6_rt_addr_add);
EXPORT_SYMBOL(ip6_rt_addr_del);
EXPORT_SYMBOL(ipv6_chk_addr);
EXPORT_SYMBOL(ipv6_dev_ac_inc);
EXPORT_SYMBOL(ipv6_dev_mc_dec);
EXPORT_SYMBOL(ipv6_dev_mc_inc);
EXPORT_SYMBOL(ipv6_ext_hdr);
EXPORT_SYMBOL(ipv6_get_device);
EXPORT_SYMBOL(ipv6_get_ifaddr);
EXPORT_SYMBOL(ipv6_get_lladdr);
EXPORT_SYMBOL(ipv6_get_prefix_entries);
EXPORT_SYMBOL(ipv6_get_saddr);
EXPORT_SYMBOL(ipv6_skip_exthdr);
EXPORT_SYMBOL(ipv6_txoptions_grow);
#ifdef USE_IPV6_MOBILITY
EXPORT_SYMBOL(mipv6_functions);
EXPORT_SYMBOL(mipv6_invalidate_calls);
#endif
EXPORT_SYMBOL(nd_tbl);
EXPORT_SYMBOL(ndisc_mc_map);
EXPORT_SYMBOL(ndisc_send_na);
EXPORT_SYMBOL(ndisc_send_ns);
EXPORT_SYMBOL(ndisc_send_rs);
EXPORT_SYMBOL(register_inet6addr_notifier);
EXPORT_SYMBOL(rt6_lock);
EXPORT_SYMBOL(rt6_lookup);
EXPORT_SYMBOL(rt6_purge_dflt_routers);
EXPORT_SYMBOL(unregister_inet6addr_notifier);
EXPORT_SYMBOL(ndisc_next_option);
EXPORT_SYMBOL(ndisc_parse_options);
